// Push Switch([^[)̃XLeXg
//
// Input Port P2.0  : Push Switch (LowON, HiOFFjOtPullUpRKv
// Input Port P2.1  : Push Switch (LowON, HiOFFjOtPullUpRKv
// Output Port P1.0 : LED (Hiœ_, Lowŏ)@@@OtPullDownRKv
//
// gp^C}[ : Watch Dog Timer C^[oƂĎgp
//
//  
// 2007.1.25

#include "msp430x42x0.h"
#include "lcd.h"

#define SW_ON  1
#define SW_OFF 0

#define DISP_ON    "ON  "
#define DISP_OFF   "OFF "

unsigned char sw1;//P2.0 Push Switch1 ON=1,OFF=0
unsigned char sw2;//P2.1 Push Switch2 ON=1,OFF=0
unsigned char old_sw1;//sw1̈O̒l
unsigned char old_sw2;//sw2̈O̒l

//XCb`
void initSW()
{
  if((P2IN & BIT0)==0) sw1 = SW_ON;//LowON, HiOFF
  else sw1 = SW_OFF;
  
  if((P2IN & BIT1)==0) sw2 = SW_ON;//LowON, HiOFF
  else sw2 = SW_OFF;

  old_sw1 = sw1;
  old_sw2 = sw2;
}

int main( void )
{
  int n1;//sw1ONJEgp
  int n2;//sw2ONJEgp
  
  WDTCTL = WDTPW + WDTHOLD;//WDT̒~

#define CLK6MHz //6MHzɂƂLɂA1MHz(l̎g)ɂƂRgɂ
  
#ifdef CLK6MHz  
  //MCLK=94 x ACLK x 2 = 6.160MHz̏ꍇ
  SCFQCTL = 94 - 1;//MCLK=94 x ACLK x 2 = 6.16MHz
  FLL_CTL0 = DCOPLUS + XCAP18PF;//DCOPLUS = 1, eʕׂ18pF
  SCFI0 = FLLD_2 + FN2;//D=2, 2.2`17MHz
#else  
  // MCLK=32 x ACLK x 1 = 1.048MHz̏ꍇ(l̎g)
  FLL_CTL0 = XCAP18PF;//DCOPLUS = 0, eʕׂ18pF
#endif
  
  P2DIR &= ~(BIT1 + BIT0); //P2.1, P2.0͂ɐݒi͐ݒ͏ȗj
  P1DIR |= BIT0; //P1.0o͂ɐݒ
//  P1DIR |= BIT1; //MCLKP1.1o
//  P1DIR |= BIT5; //ACLKP1.5o

  lcd_init();//lcd
  lcd_cls();//lcd\NA
  lcd_gotopos(0,0);//lcd\ʒux=0,y=0
  lcd_putstr("sw1=");
  lcd_gotopos(0,1);//lcd\ʒux=0,y=1
  lcd_putstr("sw2=");

  n1 = 0;
  n2 = 0;
  initSW();//XCb`
  if(sw1==SW_ON){
      lcd_gotopos(4,0);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_ON);
  }
  else{
      lcd_gotopos(4,0);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_OFF);
  }
  if(sw2==SW_ON){
      lcd_gotopos(4,1);//lcd\ʒux=0,y=1
      lcd_putstr(DISP_ON);
  }
  else{
      lcd_gotopos(4,1);//lcd\ʒux=0,y=1
      lcd_putstr(DISP_OFF);
  }
  
  WDTCTL = WDT_ADLY_16;//WDT̃C^[o[hݒ 16msec (fACLK=32KHẑƂ)
  IE1 |= WDTIE;//WDTݗL
  _BIS_SR(GIE);//݋

  do
  {
    if(old_sw1==SW_OFF && sw1==SW_ON){//OFFON
      old_sw1 = SW_ON;
      lcd_gotopos(4,0);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_ON);
      n1++;
      if(n1>9) n1=0;
      lcd_putch('0' + n1);//ON̉񐔂\(0`9)
    }
    else if(old_sw1==SW_ON && sw1==SW_OFF){//ONOFF
      old_sw1 = SW_OFF;
      lcd_gotopos(4,0);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_OFF);
    }

    if(old_sw2==SW_OFF && sw2==SW_ON){//OFFON
      old_sw2 = SW_ON;
      lcd_gotopos(4,1);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_ON);
      n2++;
      if(n2>9) n2=0;
      lcd_putch('0' + n2);//ON̉񐔂\(0`9)
    }
    else if(old_sw2==SW_ON && sw2==SW_OFF){//ONOFF
      old_sw2 = SW_OFF;
      lcd_gotopos(4,1);//lcd\ʒux=0,y=0
      lcd_putstr(DISP_OFF);
    }
  }while(1);
  
  return 0;
}

//WDT݃[`
#pragma vector=WDT_VECTOR
__interrupt void WDT (void)
{
  if((P2IN & BIT0)==0) sw1 = SW_ON;//LowON, HiOFF
  else sw1 = SW_OFF;
  
  if((P2IN & BIT1)==0) sw2 = SW_ON;//LowON, HiOFF
  else sw2 = SW_OFF;

  P1OUT ^= BIT0;// P1.0̏o͂𔽓]i荞݊mFpLED_Łj
}

